"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var qs = require("qs");
exports.defaults = {
    baseUrl: '',
    args: {
        mode: 'cors',
        credentials: 'same-origin',
        headers: {
            Accept: 'application/json',
            'Content-Type': 'application/json'
        }
    },
    qs: {
        stringify: {
            addQueryPrefix: true
        },
        parse: {
            ignoreQueryPrefix: true
        }
    }
};
var Fetcher = /** @class */ (function () {
    function Fetcher(config) {
        if (config === void 0) { config = exports.defaults; }
        var _this = this;
        this.config = config;
        this.fetcher = function (url, options, catchError) {
            if (options === void 0) { options = {}; }
            if (catchError === void 0) { catchError = true; }
            return __awaiter(_this, void 0, void 0, function () {
                var _a, type, _b, baseUrl, _c, method, _d, headers, query, body, _e, withData, rest, _f, baseHeaders, restArgs, args, search, data, contentType, error, response, e_1, error;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0:
                            _a = options.type, type = _a === void 0 ? 'json' : _a, _b = options.baseUrl, baseUrl = _b === void 0 ? this.config.baseUrl : _b, _c = options.method, method = _c === void 0 ? 'get' : _c, _d = options.headers, headers = _d === void 0 ? {} : _d, query = options.query, body = options.body, _e = options.withData, withData = _e === void 0 ? false : _e, rest = __rest(options, ["type", "baseUrl", "method", "headers", "query", "body", "withData"]);
                            _f = this.config.args, baseHeaders = _f.headers, restArgs = __rest(_f, ["headers"]);
                            args = __assign({}, restArgs, { method: method.toUpperCase() }, rest, { headers: __assign({}, baseHeaders, headers) });
                            search = '';
                            if (type === 'form-data') {
                                args.body = body;
                                search = this.stringifyQuery(query);
                                delete args.headers['Content-Type'];
                            }
                            else if (type === 'json') {
                                if (args.method === 'GET') {
                                    search = this.stringifyQuery(query);
                                    if (body) {
                                        console.error('Warning: GET method doesn`t have a request body, you should use `query`');
                                    }
                                }
                                else {
                                    if (body) {
                                        args.body = typeof body === 'string' ? body : JSON.stringify(body);
                                    }
                                    if (query) {
                                        search = this.stringifyQuery(query);
                                    }
                                }
                            }
                            else {
                                throw new Error("Type '" + type + "' - is not supported in the Fetcher");
                            }
                            _g.label = 1;
                        case 1:
                            _g.trys.push([1, 13, , 14]);
                            return [4 /*yield*/, fetch(baseUrl + url + search, args)];
                        case 2:
                            data = _g.sent();
                            contentType = data.headers.get('content-type');
                            if (!(data.status >= 400)) return [3 /*break*/, 7];
                            error = void 0;
                            if (!(contentType && contentType.indexOf('application/json') !== -1)) return [3 /*break*/, 4];
                            return [4 /*yield*/, data.json()];
                        case 3:
                            error = _g.sent();
                            return [3 /*break*/, 6];
                        case 4: return [4 /*yield*/, data.text()];
                        case 5:
                            error = _g.sent();
                            _g.label = 6;
                        case 6: throw { error: error, data: data };
                        case 7:
                            response = void 0;
                            if (!(contentType && contentType.indexOf('application/json') !== -1)) return [3 /*break*/, 9];
                            return [4 /*yield*/, data.json()];
                        case 8:
                            response = _g.sent();
                            return [3 /*break*/, 11];
                        case 9: return [4 /*yield*/, data.text()];
                        case 10:
                            response = _g.sent();
                            _g.label = 11;
                        case 11: return [2 /*return*/, withData ? { response: response, data: data } : response];
                        case 12: return [3 /*break*/, 14];
                        case 13:
                            e_1 = _g.sent();
                            error = e_1.data ? e_1 : { data: e_1 };
                            if (catchError && typeof this.config.onFail === 'function') {
                                return [2 /*return*/, this.config.onFail(error, { url: url, options: options })];
                            }
                            throw error;
                        case 14: return [2 /*return*/];
                    }
                });
            });
        };
        this.stringifyQuery = function (params) {
            return qs.stringify(params, _this.config.qs.stringify) || '';
        };
        this.parseQuery = function (queryString) {
            return qs.parse(queryString, _this.config.qs.parse);
        };
        this.config = config;
    }
    return Fetcher;
}());
exports.default = Fetcher;
